function wjkH = doSelfSupLearning(wjkH, reseto, xp, yH);

%This function implements SOARD self-supervised output learning. It takes
%weights wjk, wkj, experience, and yj activity as input, and returns
%weights wjk and wkj.

if any(reseto==-1)
    contamo2=contamo2+1;
    etos=find(reseto==-1);
    expert=xp/maxXP;
    expert(find(xp<0))=0;
    for xx=1:length(etos)
        masko=find(wjkH(:,etos(xx))==1);
        maskoyH=yH;
        maskoyH(masko)=0;
        wjkH(:,etos(xx))=wjkH(:,etos(xx))-(0.1*maskoyH*expert(etos(xx)));
    end;
end;

if any(reseto==1)
    contamo=contamo+1;
    etos=find(reseto==1);
    expert=xp/maxXP;
    expert(find(xp<0))=0;
    for xx=1:length(etos)
        masko=find(wjkH(:,etos(xx))>0.9);
        maskoyH=yH;
        maskoyH(masko)=0;
        %wjkH(:,etos(xx))=wjkH(:,etos(xx))+(0.5*maskoyH);
        ymenosw=maskoyH-wjkH(:,etos(xx));
        ymenosw(find(ymenosw<0))=0;
        wjkH(:,etos(xx))=wjkH(:,etos(xx))+(0.5*ymenosw*expert(etos(xx)));
    end;
end;