function dy = rigido(t,y)

%This function sets the differential equations for rule based inference in
%SOARD

global mato sigma_k
dy = zeros(6,1);    % a column vector

%A=[-1 0 0; -0.4 -1 0; 0.9 0 -1];
%B=[0.75; 0.15; 0.1];

%dy = A*y + B;

dy(1) = -y(1) + max([y(2)*mato(2,1),y(3)*mato(3,1),y(4)*mato(4,1),y(5)*mato(5,1),y(6)*mato(6,1)]) + min([y(2)*mato(2,1),y(3)*mato(3,1),y(4)*mato(4,1),y(5)*mato(5,1),y(6)*mato(6,1)]) + sigma_k(1);
dy(2) = -y(2) + max([y(1)*mato(1,2),y(3)*mato(3,2),y(4)*mato(4,2),y(5)*mato(5,2),y(6)*mato(6,2)]) + min([y(1)*mato(1,2),y(3)*mato(3,2),y(4)*mato(4,2),y(5)*mato(5,2),y(6)*mato(6,2)]) + sigma_k(2);
dy(3) = -y(3) + max([y(1)*mato(1,3),y(2)*mato(2,3),y(4)*mato(4,3),y(5)*mato(5,3),y(6)*mato(6,3)]) + min([y(1)*mato(1,3),y(2)*mato(2,3),y(4)*mato(4,3),y(5)*mato(5,3),y(6)*mato(6,3)]) + sigma_k(3);
dy(4) = -y(4) + max([y(1)*mato(1,4),y(2)*mato(2,4),y(3)*mato(3,4),y(5)*mato(5,4),y(6)*mato(6,4)]) + min([y(1)*mato(1,4),y(2)*mato(2,4),y(3)*mato(3,4),y(5)*mato(5,4),y(6)*mato(6,4)]) + sigma_k(4);
dy(5) = -y(5) + max([y(1)*mato(1,5),y(2)*mato(2,5),y(3)*mato(3,5),y(4)*mato(4,5),y(6)*mato(6,5)]) + min([y(1)*mato(1,5),y(2)*mato(2,5),y(3)*mato(3,5),y(4)*mato(4,5),y(6)*mato(6,5)]) + sigma_k(5);
dy(6) = -y(6) + max([y(1)*mato(1,6),y(2)*mato(2,6),y(3)*mato(3,6),y(4)*mato(4,6),y(5)*mato(6,6)]) + min([y(1)*mato(1,6),y(2)*mato(2,6),y(3)*mato(3,6),y(4)*mato(4,6),y(5)*mato(6,6)]) + sigma_k(6);